/*!
  \example
  \brief AXL̃Tv

  \author Satofumi KAMIMURA

  $Id$

  usage:
  ./(this program) --urg_port=(COM Port)
*/

#include "UrgCtrl.h"
#include "Delay.h"
#include <SDL.h>

using namespace beego;


int main(int argc, char *argv[]) {

  // ZTƂ̐ڑ
  UrgCtrl urg;
  if (! urg.connect(argc, argv)) {
    printf("UrgCtrl::connect: %s\n", urg.what());
    exit(1);
  }
  urg.setCaptureMode(UrgCtrl::AutoCapture);

  // f[^̎M
  enum { TryTimes = 10 };
  int data_max = urg.getMaxDataLength();
  long* data = new long[data_max];
  int delay_msec = urg.getScanMsec();
  for (int i = 0; i < TryTimes; ++i) {
    delay(delay_msec);

    // f[^̊i[
    int n = urg.capture(data, data_max);
    if (n <= 0) {
      // f[^MȂ΁A΂炭ҋ@čēxf[^擾s
      fprintf(stderr, "\n");
      continue;
    }
    // ʃf[^ƃ^CX^v\
    unsigned long ticks = urg.getRawTimestamp();
    printf("ticks: %ld, length: %ld\n", ticks, data[data_max / 2]);
  }
  delete [] data;

  return 0;
}
